/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleBigQueryStorageRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleBigQueryStorageRequest{}

// GoogleBigQueryStorageRequest struct for GoogleBigQueryStorageRequest
type GoogleBigQueryStorageRequest struct {
	Label     *string `json:"label,omitempty"`
	Type      *string `json:"type,omitempty"`
	OAuthId   *int32  `json:"o_auth_id,omitempty"`
	ProjectId *string `json:"projectId,omitempty"`
	DatasetId *string `json:"datasetId,omitempty"`
}

// NewGoogleBigQueryStorageRequest instantiates a new GoogleBigQueryStorageRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleBigQueryStorageRequest() *GoogleBigQueryStorageRequest {
	this := GoogleBigQueryStorageRequest{}
	return &this
}

// NewGoogleBigQueryStorageRequestWithDefaults instantiates a new GoogleBigQueryStorageRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleBigQueryStorageRequestWithDefaults() *GoogleBigQueryStorageRequest {
	this := GoogleBigQueryStorageRequest{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleBigQueryStorageRequest) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryStorageRequest) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleBigQueryStorageRequest) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleBigQueryStorageRequest) SetLabel(v string) {
	o.Label = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *GoogleBigQueryStorageRequest) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryStorageRequest) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *GoogleBigQueryStorageRequest) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *GoogleBigQueryStorageRequest) SetType(v string) {
	o.Type = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleBigQueryStorageRequest) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryStorageRequest) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleBigQueryStorageRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *GoogleBigQueryStorageRequest) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetProjectId returns the ProjectId field value if set, zero value otherwise.
func (o *GoogleBigQueryStorageRequest) GetProjectId() string {
	if o == nil || IsNil(o.ProjectId) {
		var ret string
		return ret
	}
	return *o.ProjectId
}

// GetProjectIdOk returns a tuple with the ProjectId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryStorageRequest) GetProjectIdOk() (*string, bool) {
	if o == nil || IsNil(o.ProjectId) {
		return nil, false
	}
	return o.ProjectId, true
}

// HasProjectId returns a boolean if a field has been set.
func (o *GoogleBigQueryStorageRequest) HasProjectId() bool {
	if o != nil && !IsNil(o.ProjectId) {
		return true
	}

	return false
}

// SetProjectId gets a reference to the given string and assigns it to the ProjectId field.
func (o *GoogleBigQueryStorageRequest) SetProjectId(v string) {
	o.ProjectId = &v
}

// GetDatasetId returns the DatasetId field value if set, zero value otherwise.
func (o *GoogleBigQueryStorageRequest) GetDatasetId() string {
	if o == nil || IsNil(o.DatasetId) {
		var ret string
		return ret
	}
	return *o.DatasetId
}

// GetDatasetIdOk returns a tuple with the DatasetId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryStorageRequest) GetDatasetIdOk() (*string, bool) {
	if o == nil || IsNil(o.DatasetId) {
		return nil, false
	}
	return o.DatasetId, true
}

// HasDatasetId returns a boolean if a field has been set.
func (o *GoogleBigQueryStorageRequest) HasDatasetId() bool {
	if o != nil && !IsNil(o.DatasetId) {
		return true
	}

	return false
}

// SetDatasetId gets a reference to the given string and assigns it to the DatasetId field.
func (o *GoogleBigQueryStorageRequest) SetDatasetId(v string) {
	o.DatasetId = &v
}

func (o GoogleBigQueryStorageRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleBigQueryStorageRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.ProjectId) {
		toSerialize["projectId"] = o.ProjectId
	}
	if !IsNil(o.DatasetId) {
		toSerialize["datasetId"] = o.DatasetId
	}
	return toSerialize, nil
}

type NullableGoogleBigQueryStorageRequest struct {
	value *GoogleBigQueryStorageRequest
	isSet bool
}

func (v NullableGoogleBigQueryStorageRequest) Get() *GoogleBigQueryStorageRequest {
	return v.value
}

func (v *NullableGoogleBigQueryStorageRequest) Set(val *GoogleBigQueryStorageRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleBigQueryStorageRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleBigQueryStorageRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleBigQueryStorageRequest(val *GoogleBigQueryStorageRequest) *NullableGoogleBigQueryStorageRequest {
	return &NullableGoogleBigQueryStorageRequest{value: val, isSet: true}
}

func (v NullableGoogleBigQueryStorageRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleBigQueryStorageRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
